CONTENTS OF THIS FILE
---------------------

 * Introduction
 * Requirements
 * Installation
 * Configuration
 * Maintainers


INTRODUCTION
------------

This will add a new field formatter and field widget as map in a geofield
field, using the maplibre library.
The module https://www.drupal.org/project/maplibre_gl is mandatory.
After enabled you can choose the formatter of a geofield as a "maplibre gl",
in manage display of any entity that has a geofield field. Also it allows to
choose the widget of a geofield as a "maplibre gl" in manage form display of
an entity that has a geofield field.


 * For a full description of the module, visit the project page:
   https://www.drupal.org/project/geofield_maplibre_gl

 * To submit bug reports and feature suggestions, or to track changes:
   https://www.drupal.org/project/issues/geofield_maplibre_gl


REQUIREMENTS
------------

This module requires:

 * https://www.drupal.org/project/maplibre_gl
 * https://www.drupal.org/project/geofield


INSTALLATION
------------

 * Install the Geofield maplibre gl module as you would normally install
   a contributed Drupal module.
   Visit https://www.drupal.org/node/1897420 for further information.


CONFIGURATION
-------------

    1. Navigate to Administration > Extend and enable the module.
    2. Navigate to Administration > Structure > Content type > Manage fields >
       Add a new field "Geofield".

For formatter:
    1. Navigate to Administration > Structure > Content type > Manage display >
       and choose "Maplibre GL" Format.
    2. To make it work you could use any of the providers from
       https://github.com/maplibre/awesome-maplibre?tab=readme-ov-file#maptile-providers
       (list may be outdated so you could search for other tile providers), for example
       you could obtain a free API key from maptiler(https://cloud.maptiler.com), mapbox,
       clockworkmicro, or other tile servers. And then choose the representation of the
       point:
        * Marker: https://maplibre.org/maplibre-gl-js/docs/examples/add-a-marker/
        * Circle: https://maplibre.org/maplibre-gl-js/docs/examples/multiple-geometries/
        * Icon: https://docs.maplibre.com/maplibre-gl-js/example/geojson-markers or
          https://maplibre.org/maplibre-gl-js/docs/examples/filter-markers/
        * Custom image: https://maplibre.org/maplibre-gl-js/docs/examples/custom-marker-icons/
        * Custom Image from other field in the same entity, with the choosen image
          view mode.

For form widget:
    1. Navigate to Administration > Structure > Content type > Manage form display >
       and choose "Maplibre GL" Format.
    2. To make it work you could use any of the providers from
       https://github.com/maplibre/awesome-maplibre?tab=readme-ov-file#maptile-providers
       (list may be outdated so you could search for other tile providers), for example
       you could obtain a free API key from maptiler(https://cloud.maptiler.com), mapbox,
       clockworkmicro, or other tile servers. Optionally you could enable html5
       geoposition.

TROUBLESHOOTING
---------------
* "recursive str_replace": If any error of recursive str_replace happens,
          make it sure that an appropiate view mode is used,with special focus
          that the view mode is not using the geofield_maplibre_gl formatter
          again and again.
* tooltips: Every representated point comes with a tooltip(as
          as https://docs.maplibre.com/maplibre-gl-js/example/popup-on-click/)
          with the choosen view mode of the same entity.

* For icons, every provider uses its own origin, and so is difficult to guess
the correct ones without inspecting. Maptiler for example uses material icons
with a _15 suffix (maptiler uses 15x15 icons). But some other providers are
not using material icons...

MAINTAINERS
-----------

 * Aleix Quintana (aleix) - https://www.drupal.org/u/aleix

Supporting organizations:
 * Communia - https://www.drupal.org/communia
